//
// GroupsAPI.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Foundation
import Alamofire


open class GroupsAPI {
    /**
     Add user to specified group

     - parameter body: (body)  
     - parameter groupId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func addGroupMembers(body: GroupMembersBody, groupId: Int, completion: @escaping ((_ data: APIResponseStatusOK?,_ error: Error?) -> Void)) {
        addGroupMembersWithRequestBuilder(body: body, groupId: groupId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Add user to specified group
     - POST /api/v1/groups/{group_id}/members

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "status" : "ok"
}}]
     - parameter body: (body)  
     - parameter groupId: (path)  

     - returns: RequestBuilder<APIResponseStatusOK> 
     */
    open class func addGroupMembersWithRequestBuilder(body: GroupMembersBody, groupId: Int) -> RequestBuilder<APIResponseStatusOK> {
        var path = "/api/v1/groups/{group_id}/members"
        let groupIdPreEscape = "\(groupId)"
        let groupIdPostEscape = groupIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{group_id}", with: groupIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = JSONEncodingHelper.encodingParameters(forEncodableObject: body)
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<APIResponseStatusOK>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: (url?.string ?? URLString), parameters: parameters, isBody: true)
    }
    /**
     Add place to specified group

     - parameter body: (body)  
     - parameter groupId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func addGroupPlaces(body: GroupPlacesBody, groupId: Int, completion: @escaping ((_ data: APIResponseStatusOK?,_ error: Error?) -> Void)) {
        addGroupPlacesWithRequestBuilder(body: body, groupId: groupId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Add place to specified group
     - POST /api/v1/groups/{group_id}/places

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "status" : "ok"
}}]
     - parameter body: (body)  
     - parameter groupId: (path)  

     - returns: RequestBuilder<APIResponseStatusOK> 
     */
    open class func addGroupPlacesWithRequestBuilder(body: GroupPlacesBody, groupId: Int) -> RequestBuilder<APIResponseStatusOK> {
        var path = "/api/v1/groups/{group_id}/places"
        let groupIdPreEscape = "\(groupId)"
        let groupIdPostEscape = groupIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{group_id}", with: groupIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = JSONEncodingHelper.encodingParameters(forEncodableObject: body)
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<APIResponseStatusOK>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: (url?.string ?? URLString), parameters: parameters, isBody: true)
    }
    /**
     Create new group

     - parameter body: (body)  
     - parameter organizationId: (query)  (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func createGroup(body: GroupCreate, organizationId: Int? = nil, completion: @escaping ((_ data: GroupGet?,_ error: Error?) -> Void)) {
        createGroupWithRequestBuilder(body: body, organizationId: organizationId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Create new group
     - POST /api/v1/groups

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "is_internal" : true,
  "place_count" : 5,
  "user_count" : 1,
  "organization_id" : 6,
  "name" : "name",
  "description" : "description",
  "id" : 0,
  "organization_name" : "organization_name"
}}]
     - parameter body: (body)  
     - parameter organizationId: (query)  (optional)

     - returns: RequestBuilder<GroupGet> 
     */
    open class func createGroupWithRequestBuilder(body: GroupCreate, organizationId: Int? = nil) -> RequestBuilder<GroupGet> {
        let path = "/api/v1/groups"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = JSONEncodingHelper.encodingParameters(forEncodableObject: body)
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "organization_id": organizationId?.encodeToJSON()
        ])


        let requestBuilder: RequestBuilder<GroupGet>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: (url?.string ?? URLString), parameters: parameters, isBody: true)
    }
    /**
     Delete group with provided ID

     - parameter groupId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func deleteGroup(groupId: Int, completion: @escaping ((_ data: APIResponseStatusOK?,_ error: Error?) -> Void)) {
        deleteGroupWithRequestBuilder(groupId: groupId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Delete group with provided ID
     - DELETE /api/v1/groups/{group_id}

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "status" : "ok"
}}]
     - parameter groupId: (path)  

     - returns: RequestBuilder<APIResponseStatusOK> 
     */
    open class func deleteGroupWithRequestBuilder(groupId: Int) -> RequestBuilder<APIResponseStatusOK> {
        var path = "/api/v1/groups/{group_id}"
        let groupIdPreEscape = "\(groupId)"
        let groupIdPostEscape = groupIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{group_id}", with: groupIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<APIResponseStatusOK>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "DELETE", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Get group with provided ID

     - parameter groupId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func getGroup(groupId: Int, completion: @escaping ((_ data: GroupGet?,_ error: Error?) -> Void)) {
        getGroupWithRequestBuilder(groupId: groupId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Get group with provided ID
     - GET /api/v1/groups/{group_id}
     - 

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "is_internal" : true,
  "place_count" : 5,
  "user_count" : 1,
  "organization_id" : 6,
  "name" : "name",
  "description" : "description",
  "id" : 0,
  "organization_name" : "organization_name"
}}]
     - parameter groupId: (path)  

     - returns: RequestBuilder<GroupGet> 
     */
    open class func getGroupWithRequestBuilder(groupId: Int) -> RequestBuilder<GroupGet> {
        var path = "/api/v1/groups/{group_id}"
        let groupIdPreEscape = "\(groupId)"
        let groupIdPostEscape = groupIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{group_id}", with: groupIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<GroupGet>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Get list of group members

     - parameter groupId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func getGroupMembers(groupId: Int, completion: @escaping ((_ data: UserList?,_ error: Error?) -> Void)) {
        getGroupMembersWithRequestBuilder(groupId: groupId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Get list of group members
     - GET /api/v1/groups/{group_id}/members
     - 

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "users" : [ {
    "avatar_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "is_active" : true,
    "is_superuser" : true,
    "avatar_url" : "http://example.com/aeiou",
    "role_id" : 5,
    "organization_id" : 6,
    "last_name" : "last_name",
    "groups" : [ {
      "name" : "name",
      "id" : 1
    }, {
      "name" : "name",
      "id" : 1
    } ],
    "id" : 0,
    "organization_name" : "organization_name",
    "first_name" : "first_name",
    "email" : ""
  }, {
    "avatar_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "is_active" : true,
    "is_superuser" : true,
    "avatar_url" : "http://example.com/aeiou",
    "role_id" : 5,
    "organization_id" : 6,
    "last_name" : "last_name",
    "groups" : [ {
      "name" : "name",
      "id" : 1
    }, {
      "name" : "name",
      "id" : 1
    } ],
    "id" : 0,
    "organization_name" : "organization_name",
    "first_name" : "first_name",
    "email" : ""
  } ]
}}]
     - parameter groupId: (path)  

     - returns: RequestBuilder<UserList> 
     */
    open class func getGroupMembersWithRequestBuilder(groupId: Int) -> RequestBuilder<UserList> {
        var path = "/api/v1/groups/{group_id}/members"
        let groupIdPreEscape = "\(groupId)"
        let groupIdPostEscape = groupIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{group_id}", with: groupIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<UserList>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Get list of group places

     - parameter groupId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func getGroupPlaces(groupId: Int, completion: @escaping ((_ data: PlaceList?,_ error: Error?) -> Void)) {
        getGroupPlacesWithRequestBuilder(groupId: groupId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Get list of group places
     - GET /api/v1/groups/{group_id}/places
     - 

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "places" : [ {
    "camera_count" : 5,
    "updated_at" : "2000-01-23T04:56:07.000+00:00",
    "latitude" : 0.8008281904610115,
    "name" : "name",
    "description" : "description",
    "created_at" : "2000-01-23T04:56:07.000+00:00",
    "plan_count" : 5,
    "id" : 1,
    "longitude" : 6.027456183070403
  }, {
    "camera_count" : 5,
    "updated_at" : "2000-01-23T04:56:07.000+00:00",
    "latitude" : 0.8008281904610115,
    "name" : "name",
    "description" : "description",
    "created_at" : "2000-01-23T04:56:07.000+00:00",
    "plan_count" : 5,
    "id" : 1,
    "longitude" : 6.027456183070403
  } ]
}}]
     - parameter groupId: (path)  

     - returns: RequestBuilder<PlaceList> 
     */
    open class func getGroupPlacesWithRequestBuilder(groupId: Int) -> RequestBuilder<PlaceList> {
        var path = "/api/v1/groups/{group_id}/places"
        let groupIdPreEscape = "\(groupId)"
        let groupIdPostEscape = groupIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{group_id}", with: groupIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<PlaceList>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Get list of groups

     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func getGroups(completion: @escaping ((_ data: GroupList?,_ error: Error?) -> Void)) {
        getGroupsWithRequestBuilder().execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Get list of groups
     - GET /api/v1/groups
     - 

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "groups" : [ {
    "is_internal" : true,
    "place_count" : 5,
    "user_count" : 1,
    "organization_id" : 6,
    "name" : "name",
    "description" : "description",
    "id" : 0,
    "organization_name" : "organization_name"
  }, {
    "is_internal" : true,
    "place_count" : 5,
    "user_count" : 1,
    "organization_id" : 6,
    "name" : "name",
    "description" : "description",
    "id" : 0,
    "organization_name" : "organization_name"
  } ]
}}]

     - returns: RequestBuilder<GroupList> 
     */
    open class func getGroupsWithRequestBuilder() -> RequestBuilder<GroupList> {
        let path = "/api/v1/groups"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<GroupList>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Remove user from specified group

     - parameter body: (body)  
     - parameter groupId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func removeGroupMembers(body: GroupMembersBody, groupId: Int, completion: @escaping ((_ data: APIResponseStatusOK?,_ error: Error?) -> Void)) {
        removeGroupMembersWithRequestBuilder(body: body, groupId: groupId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Remove user from specified group
     - DELETE /api/v1/groups/{group_id}/members
     - 

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "status" : "ok"
}}]
     - parameter body: (body)  
     - parameter groupId: (path)  

     - returns: RequestBuilder<APIResponseStatusOK> 
     */
    open class func removeGroupMembersWithRequestBuilder(body: GroupMembersBody, groupId: Int) -> RequestBuilder<APIResponseStatusOK> {
        var path = "/api/v1/groups/{group_id}/members"
        let groupIdPreEscape = "\(groupId)"
        let groupIdPostEscape = groupIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{group_id}", with: groupIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = JSONEncodingHelper.encodingParameters(forEncodableObject: body)
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<APIResponseStatusOK>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "DELETE", URLString: (url?.string ?? URLString), parameters: parameters, isBody: true)
    }
    /**
     Remove place from specified group

     - parameter body: (body)  
     - parameter groupId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func removeGroupPlaces(body: GroupPlacesBody, groupId: Int, completion: @escaping ((_ data: APIResponseStatusOK?,_ error: Error?) -> Void)) {
        removeGroupPlacesWithRequestBuilder(body: body, groupId: groupId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Remove place from specified group
     - DELETE /api/v1/groups/{group_id}/places
     - 

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "status" : "ok"
}}]
     - parameter body: (body)  
     - parameter groupId: (path)  

     - returns: RequestBuilder<APIResponseStatusOK> 
     */
    open class func removeGroupPlacesWithRequestBuilder(body: GroupPlacesBody, groupId: Int) -> RequestBuilder<APIResponseStatusOK> {
        var path = "/api/v1/groups/{group_id}/places"
        let groupIdPreEscape = "\(groupId)"
        let groupIdPostEscape = groupIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{group_id}", with: groupIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = JSONEncodingHelper.encodingParameters(forEncodableObject: body)
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<APIResponseStatusOK>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "DELETE", URLString: (url?.string ?? URLString), parameters: parameters, isBody: true)
    }
    /**
     Search groups by provided query

     - parameter body: (body)  
     - parameter organizationId: (query)  (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func searchGroups(body: GroupSearchBody, organizationId: Int? = nil, completion: @escaping ((_ data: GroupList?,_ error: Error?) -> Void)) {
        searchGroupsWithRequestBuilder(body: body, organizationId: organizationId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Search groups by provided query
     - POST /api/v1/groups/search

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "groups" : [ {
    "is_internal" : true,
    "place_count" : 5,
    "user_count" : 1,
    "organization_id" : 6,
    "name" : "name",
    "description" : "description",
    "id" : 0,
    "organization_name" : "organization_name"
  }, {
    "is_internal" : true,
    "place_count" : 5,
    "user_count" : 1,
    "organization_id" : 6,
    "name" : "name",
    "description" : "description",
    "id" : 0,
    "organization_name" : "organization_name"
  } ]
}}]
     - parameter body: (body)  
     - parameter organizationId: (query)  (optional)

     - returns: RequestBuilder<GroupList> 
     */
    open class func searchGroupsWithRequestBuilder(body: GroupSearchBody, organizationId: Int? = nil) -> RequestBuilder<GroupList> {
        let path = "/api/v1/groups/search"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = JSONEncodingHelper.encodingParameters(forEncodableObject: body)
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "organization_id": organizationId?.encodeToJSON()
        ])


        let requestBuilder: RequestBuilder<GroupList>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: (url?.string ?? URLString), parameters: parameters, isBody: true)
    }
    /**
     Update group with provided ID

     - parameter body: (body)  
     - parameter groupId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func updateGroup(body: GroupUpdate, groupId: Int, completion: @escaping ((_ data: GroupGet?,_ error: Error?) -> Void)) {
        updateGroupWithRequestBuilder(body: body, groupId: groupId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Update group with provided ID
     - PUT /api/v1/groups/{group_id}
     - 

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "is_internal" : true,
  "place_count" : 5,
  "user_count" : 1,
  "organization_id" : 6,
  "name" : "name",
  "description" : "description",
  "id" : 0,
  "organization_name" : "organization_name"
}}]
     - parameter body: (body)  
     - parameter groupId: (path)  

     - returns: RequestBuilder<GroupGet> 
     */
    open class func updateGroupWithRequestBuilder(body: GroupUpdate, groupId: Int) -> RequestBuilder<GroupGet> {
        var path = "/api/v1/groups/{group_id}"
        let groupIdPreEscape = "\(groupId)"
        let groupIdPostEscape = groupIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{group_id}", with: groupIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = JSONEncodingHelper.encodingParameters(forEncodableObject: body)
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<GroupGet>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "PUT", URLString: (url?.string ?? URLString), parameters: parameters, isBody: true)
    }
}
